package dev.shadowsoffire.apotheosis.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.apotheosis.util.GemIngredient;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.GsonHelper;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraftforge.common.crafting.IIngredientSerializer;

public class Serializer implements IIngredientSerializer<GemIngredient> {
  public static final Serializer INSTANCE = new Serializer();
  
  public GemIngredient parse(FriendlyByteBuf buffer) {
    DynamicHolder<LootRarity> rarity = RarityRegistry.INSTANCE.holder(buffer.m_130281_());
    return new GemIngredient(rarity);
  }
  
  public GemIngredient parse(JsonObject json) {
    DynamicHolder<LootRarity> rarity = RarityRegistry.INSTANCE.holder(new ResourceLocation(GsonHelper.m_13906_(json, "rarity")));
    return new GemIngredient(rarity);
  }
  
  public void write(FriendlyByteBuf buffer, GemIngredient ingredient) {
    buffer.m_130085_(ingredient.rarity.getId());
  }
}
